package de.brightbyte.abstraction;

import de.brightbyte.data.Functor;

public class ConvertingAccessor<T, V, W> extends AbstractAccessor<T, W> {

	protected PropertyAccessor<T, ? extends V> accessor;
	protected Functor<? extends W, V> converter;
	
	public ConvertingAccessor(PropertyAccessor<T, ? extends V> accessor, Functor<? extends W, V> converter, Class<W> type) {
		super(accessor.getName(), type);
		
		if (converter==null) throw new NullPointerException();
		if (accessor==null) throw new NullPointerException();
		
		this.converter = converter;
		this.accessor = accessor;
	}
	
	public W getValue(T obj) {
		V v = accessor.getValue(obj);
		return converter.apply(v);
	}
	
	public boolean isMutable() {
		return false;
	}
	
	public void setValue(T obj, W value) {
		throw new UnsupportedOperationException();
	}
	
}
