package de.brightbyte.abstraction;

import java.util.Collection;
import java.util.Map;

import de.brightbyte.data.Functor;
import de.brightbyte.data.MultiMap;

public class MultiMapAbstractor<V, C extends Collection<V>> implements Abstractor<MultiMap<String, V, C>> {

	public static final MultiMapAbstractor<Object, Collection<Object>> instance = new MultiMapAbstractor<Object, Collection<Object>>();
	
	@SuppressWarnings("unchecked")
	public static final <V extends Collection<?>> PropertyAccessor<MultiMap<String, ?, Collection<?>>, V> accessor(String property) {
		return new AbstractedAccessor<MultiMap<String, ?, Collection<?>> , V>(property, (Abstractor<MultiMap<String, ?, Collection<?>> >)(Object)MultiMapAbstractor.instance);
	}
	
	@SuppressWarnings("unchecked")
	public static final <V, W extends Collection<V>> PropertyAccessor<MultiMap<String, ?, Collection<?>> , V> accessor(String property, Functor<V, W> aggregator, Class<V> type) {
		PropertyAccessor<MultiMap<String, ?, Collection<?>> , W>  a = accessor(property);
		return new ProjectingAccessor<MultiMap<String, ?, Collection<?>>, W, V>(a, aggregator, type);
	}
	
	public Object getProperty(MultiMap<String, V, C> obj, String name) throws IllegalArgumentException {
		Collection<V> m = ((MultiMap<String, V, C> )(Object)obj).get(name);
		return obj.get(name);
	}

	public Class getPropertyType(String property) {
		return Object.class;
	}

	public Class<MultiMap<String, V, C>> getTargetType() {
		return (Class<MultiMap<String, V, C>>)(Object)Map.class;
	}

	public boolean isPropertyMutable(String name) {
		return true;
	}

	public void setProperty(MultiMap<String, V, C> obj, String name, Object v) throws IllegalArgumentException {
		obj.put(name, (V)v);
	}
	
	public boolean hasProperty(MultiMap<String, V, C> obj, String name) {
		return obj.containsKey(name);
	}
	
}
