package de.brightbyte.abstraction;

import de.brightbyte.data.Functor;

public class ProjectingAccessor<T, V, W>
		implements PropertyAccessor<T, W> {

	protected PropertyAccessor<T, V> accessor;
	protected Functor<W, V> projection;
	private Class<W> type;
	
	public ProjectingAccessor(PropertyAccessor<T, V> accessor, Functor<W, V> projection, Class<W> type) {
		this.type = type;
		this.accessor = accessor;
		this.projection = projection;
	}
	
	public Class<W> getType() {
		return type;
	}
	
	public String getName() {
		return accessor.getName();
	}

	public String toString() {
		return getName();
	}
		
	public W getValue(T obj) {
		V v = accessor.getValue(obj);
		return projection.apply(v);
	}
	
	public boolean isMutable() {
		return false;
	}
	
	public void setValue(T obj, W value) {
		throw new UnsupportedOperationException();
	}

}
