package de.brightbyte.data;

import java.util.Iterator;

public class MappingIterator<T, V> implements Iterator<V> {
   protected Iterator<T> iterator;
   protected Functor<V, T> mapping;
   
	public MappingIterator(Iterator<T> iterator, Functor<V, T> mapping) {
		super();
		this.iterator = iterator;
		this.mapping = mapping;
	}

	public boolean hasNext() {
		return iterator.hasNext();
	}

	public V next() {
		T obj = iterator.next();
		return mapping.apply(obj);
	}

	public void remove() {
		iterator.remove();
	}
	
}
