package de.brightbyte.data;

import java.util.Collection;
import java.util.Set;
import java.util.Map;

public interface MultiMap<K, V, C extends Collection<V>> {
	public int putAll(MultiMap<K, V, ? extends Collection<V>> m);
	public int putAll(K key, C values);

	public C get(Object key);

	public boolean put(K key, V value);

	public void clear();

	public boolean containsKey(K key);
	public boolean contains(K key, V value);

	public Set<Map.Entry<K, C>> entrySet();

	public Map<K, C> componentMap();

	public boolean isEmpty();

	public Set<K> keySet();

	public C remove(K key);

	public int size();

	public Collection<C> values();

}
