package de.brightbyte.data;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ValueListMultiMap<K, V> extends AbstractMultiMap<K, V, List<V>> {

	@Override
	protected List<V> newContainer() {
		return new ArrayList<V>();
	}

	@Override
	protected List<V> emptyContainer() {
		return Collections.emptyList();
	}

	@SuppressWarnings("unchecked")
	public static final ValueListMultiMap EMPTY = new ValueListMultiMap() {
		{ map = Collections.emptyMap(); }
	};
	
	@SuppressWarnings("unchecked")
	public static <V, C>ValueListMultiMap<V, C> empty() {
		return EMPTY;
	}
}
