package de.brightbyte.data;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class ValueSetMultiMap<K, V> extends AbstractMultiMap<K, V, Set<V>> {

	@Override
	protected Set<V> newContainer() {
		return new HashSet<V>();
	}

	@Override
	protected Set<V> emptyContainer() {
		return Collections.emptySet();
	}


	@SuppressWarnings("unchecked")
	public static final ValueSetMultiMap EMPTY = new ValueSetMultiMap() {
		{ map = Collections.emptyMap(); }
	};
	
	@SuppressWarnings("unchecked")
	public static <V, C>ValueSetMultiMap<V, C> empty() {
		return EMPTY;
	}
	
}
