package de.brightbyte.data.cursor;

import de.brightbyte.data.Functor;
import de.brightbyte.util.PersistenceException;

public class ConvertingCursor<A, B> implements DataCursor<B> {
	
	protected DataCursor<A> source;
	protected Functor<B, A> converter;

	public ConvertingCursor(DataCursor<A> source, Functor<B, A> converter) {
		if (source==null) throw new NullPointerException();
		if (converter==null) throw new NullPointerException();
		
		this.source = source;
		this.converter =  converter;
	}
	
	public void close() {
		source.close();
	}

	public B next() throws PersistenceException {
		A v = source.next();
		if (v==null) return null;
		
		return converter.apply(v);
	}

}
