package de.brightbyte.data.filter;

import java.util.Collection;

/**
 * Filter that matches if the filtered object is equal to a given sample object.
 * 
 * @author daniel
 */
public class AllElementsFilter<T> extends FilterWrapper<T, Collection<T>> { 
	public AllElementsFilter(Filter<T> filter) {
		super(filter);
	}
	
	public boolean matches(Collection<T> collection) {
		for(T obj: collection) {
			if (filter.matches(obj)) return true;
		}
		
		return false;
	}
}
