/**
 * 
 */
package de.brightbyte.data.filter;

import java.util.Iterator;


class FilteredIterator<V> implements Iterator<V> {
	private Filter<V> filter;
	private Iterator<V> iterator;
	private V next;
	private boolean hasNext;
	
	public  FilteredIterator(Iterator<V> it, Filter<V> matcher) {
		this.iterator = it;
		this.filter = matcher;
		
		scan(); 
	}
	
	private void scan() {
		hasNext = false;
		while (iterator.hasNext()) {
			hasNext = true;
			V x = iterator.next();
			if (filter.matches(x)) break;
			hasNext = false;
		}
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}

	public V next() {
		if (!hasNext) return null;
		
		V n = next;
		scan();
		return n;
	}

	public boolean hasNext() {
		return hasNext;
	}

}