package de.brightbyte.data.filter;

import de.brightbyte.data.Functor;

/**
 * Filter that matches if the filtered object is equal to a given sample object.
 * 
 * @author daniel
 */
public class MappingFilter<T, V> extends FilterWrapper<T,V> { 
	protected Functor<T, V> mapping;
	
	public MappingFilter(Filter<T> filter, Functor<T, V> mapping) {
		super(filter);
		this.mapping = mapping;
	}
	
	public boolean matches(V obj) {
		T x = mapping.apply(obj);
		
		return filter.matches(x);
	}
}
