package de.brightbyte.data.filter;

import java.util.regex.Pattern;

public class RegularExpressionFilter implements Filter<CharSequence> {

	protected Pattern pattern;
	
	public RegularExpressionFilter(String pattern, int flags) {
		this(Pattern.compile(pattern, flags));
	}
	
	public RegularExpressionFilter(Pattern pattern) {
		if (pattern==null) throw new NullPointerException();
		this.pattern = pattern;
	}
	
	public boolean matches(CharSequence s) {
		return pattern.matcher(s).matches();
	}

}
