package de.brightbyte.io;

import java.io.IOException;

public class AppendableOutput<T extends Appendable> extends AbstractOutput {
	protected T out;
	protected String newline;
	
	public AppendableOutput(T out) {
		this(out, null);
	}
	
	public AppendableOutput(T out, String newline) {
		if (newline==null) newline = System.getProperty("line.separator");
		
		this.out = out;
		this.newline = newline;
	}

	public void println(Object obj) {
		try {
			writeln(String.valueOf(obj));
		} catch (IOException e) {
			//TODO: remember?
		}
	}

	public void write(String s) throws IOException {
		out.append(s);
	}

	public void writeln(String s) throws IOException {
		write(s);
		newline();
	}

	public void close() throws IOException {
		//	noop
	}

	public void newline() throws IOException {
		write(newline);
	}

	public void flush() throws IOException {
		//noop
	}
}
