package de.brightbyte.io;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.Reader;
import java.io.UnsupportedEncodingException;

import de.brightbyte.data.cursor.DataCursor;
import de.brightbyte.text.Chunker;
import de.brightbyte.text.CsvLineChunker;

public class TsvCursor extends ChunkingCursor {
	
	public TsvCursor(InputStream in, String enc) throws UnsupportedEncodingException {
		this( new LineCursor(in, enc) );
	}

	public TsvCursor(Reader rd) {
		this(new LineCursor(rd));
	}
	
	public TsvCursor(BufferedReader reader) {
		this(new LineCursor(reader));
	}

	public TsvCursor(DataCursor<String> source) {
		this(source, CsvLineChunker.tsv);
	}
	
	public TsvCursor(DataCursor<String> source, Chunker chunker) {
		super(source, chunker);
	}

}
