package de.brightbyte.text;

import java.text.ParseException;
import java.text.ParsePosition;
import java.util.ArrayList;

public class DefaultCommandLineChunker implements Chunker {

	public static final DefaultCommandLineChunker instance = new DefaultCommandLineChunker();
	
	protected StringLiteralParser literalParser = DefaultStringLiteralParser.instance;
	
	public ArrayList<String> chunk(String s) throws ParseException {
		ParsePosition pos = new ParsePosition(0);

		ArrayList<String> chunks = new ArrayList<String>();
		
		while (pos.getIndex()<s.length()) {
			DefaultStringLiteralParser.scanTo(s, pos, " \t\r\n", true);
			char ch = s.charAt(pos.getIndex());
			
			String chunk;
			if (ch=='"' || ch=='\'') chunk = literalParser.parseStringLiteral(s, pos);
			else chunk = DefaultStringLiteralParser.scanTo(s, pos, " \t\r\n", false);
			
			chunks.add(chunk);
		}
		
		return chunks;
	}

}
