package de.brightbyte.text;

import java.text.ParseException;
import java.util.Arrays;
import java.util.regex.Pattern;

public class RegularExpressionChunker implements Chunker {
	protected Pattern pattern;

	public RegularExpressionChunker(Pattern pattern) {
		if (pattern==null) throw new NullPointerException();
		this.pattern = pattern;
	}

	public Iterable<String> chunk(String line) throws ParseException {
		String[] ww = pattern.split(line);
		return Arrays.asList(ww);
	}
}
