package de.brightbyte.util;

import de.brightbyte.io.LeveledOutput;

public class LoggingErrorHandler<T, E extends Throwable, X extends Throwable> implements ErrorHandler<T, E, X> {

	protected LeveledOutput log;
	
	public LoggingErrorHandler(LeveledOutput log) {
		if (log==null) throw new NullPointerException();
		this.log = log;
	}

	public void handleError(T context, String message, E error)  {
		if (context!=null) {
			if (message==null) message = "("+context+")";
			else if (message==null) message = "("+context+") "+message;
		}
		
		log.error(message, error);
	}

}
