package de.brightbyte.util;

import junit.framework.TestCase;

public class SubstringMatcherTest extends TestCase {

	public void testFind() {
		SubstringMatcher m;
		
		m = new SubstringMatcher();
		m.reset("test");
		assertEquals(false, m.find());
		assertEquals(0, m.matchedGroup());
		assertEquals(4, m.index());
		
		m = new SubstringMatcher("a", "b");
		m.reset("");
		assertEquals(false, m.find());
		assertEquals(0, m.matchedGroup());
		assertEquals(0, m.index());
		
		m = new SubstringMatcher("a", "b", "e");
		m.reset("test");
		assertEquals(true, m.find());
		assertEquals(3, m.matchedGroup());
		assertEquals(2, m.index());
		
		m = new SubstringMatcher("a", "b", "e");
		m.reset("test");
		m.setIndex(3);
		assertEquals(false, m.find());
		assertEquals(0, m.matchedGroup());
		assertEquals(4, m.index());
		
		//------------------------
		
		m = new SubstringMatcher("aa", "bb");
		m.reset("aabb");
		assertEquals(true, m.find());
		assertEquals(1, m.matchedGroup());
		assertEquals(2, m.index());

		assertEquals(true, m.find());
		assertEquals(2, m.matchedGroup());
		assertEquals(4, m.index());
		
		m = new SubstringMatcher("bb");
		m.reset("aabbbb");
		assertEquals(true, m.find());
		assertEquals(1, m.matchedGroup());
		assertEquals(4, m.index());

		assertEquals(true, m.find());
		assertEquals(1, m.matchedGroup());
		assertEquals(6, m.index());

		assertEquals(false, m.find());
		assertEquals(0, m.matchedGroup());
		assertEquals(6, m.index());
		
		/*
		//broken by design
		m = new SubstringMatcher("ababc");
		m.reset("abababc");
		assertEquals(true, m.find());
		assertEquals(1, m.matchedGroup());
		assertEquals(7, m.index());
		*/
	}

}
